### ZbgAbv
# options(repos="https://cran.ism.ac.jp/")
# install.packages(c("dplyr","ggplot2","magrittr","ReporteRs"), dep=T)
# system("java -version")
library(dplyr)
library(ggplot2)
library(magrittr)
library(ReporteRs)



### F͌ʂ PowerPoint ɏo
myppt <- pptx(template="C:/temp/nds.pptx")
slide.layouts(myppt) # XCh̃CAEgmF
options( "ReporteRs-fontsize"=20)
myppt <- myppt %>% 
    addSlide("Title Slide") %>%
    addTitle("Iris data" ) %>%
    addSubtitle("Table and Graph" ) %>%
    addFooter("Dummy text") %>%
    addSlide("Two Content") %>%
    addTitle("Iris data" ) %>%
    addFlexTable(vanilla.table(iris[1:10,])) %>%
    addParagraph(value=c("",
                 "This table shows Iris data (1 - 10 rows).")) %>%
    addDate() %>% addPageNumber() %>%
    addSlide("Title and Content") %>%
    addTitle("Sample Graph") %>%
    addPlot(function() plot(iris)) %>%
    addDate("Dummy date") %>% addPageNumber()
writeDoc(myppt, "c:/temp/sample.pptx")



### QlF͌ʂ WORD ɏo
Table <- vanilla.table(iris[1:10, ])
Texts <- c("aaa", "bbb")
Corrs <- FlexTable(data=cor(iris[,1:4]), add.rownames=T, 
  header.cell.props=cellProperties(background.color="#00557F"), 
  header.text.props=textProperties(color="white",
                                   font.size=11, font.weight="bold"), 
  body.text.props=textProperties(font.size=10))

options( "ReporteRs-fontsize"=10)
mydoc <- docx() %>%
  addParagraph("Table of Contents",
               par=parProperties(text.align="center")) %>%
  addTOC() %>%
  addTitle("Table Example", level=1) %>%
  addParagraph("The following table shows Iris data (1 - 10 rows).") %>%
  addParagraph(Texts, style="BulletList") %>%
  addFlexTable(Table) %>%
  addTitle("Analysis result Example", level=2) %>%
  addParagraph("Correlation matrix is shown as below.") %>%
  addFlexTable(Corrs) %>%
  addPageBreak() %>%
  addTitle("Graph Example") %>%
  addPlot(function( ) plot(iris), height=6, width=6)
writeDoc(mydoc, "c:/temp/sample.docx")



### 菇
myppt <- pptx()
slide.layouts(myppt)
slide.layouts(myppt, "Title and Content")

myppt <- pptx(template="C:/temp/nds.pptx")
slide.layouts(myppt)
slide.layouts(myppt, "Title and Content")

myppt <- pptx()
slide.layouts(myppt)
myppt <- myppt %>% 
  addSlide("Title Slide") %>%
  addTitle("Main Title" ) %>%
  addSubtitle("Sub Title" ) %>%

  addSlide("Title and Content") %>%
  addTitle("Sample Graph") %>%
  addPlot(function() plot(iris)) %>%
  addDate("") %>% addPageNumber() %>%

  addSlide("Title and Content") %>%
  addTitle("Sample Table") %>%
  addFlexTable(vanilla.table(iris[1:10,])) %>%
  addDate("") %>% addPageNumber()
writeDoc(myppt, "c:/temp/sample.pptx")



### Ot̍쐬E\t
GO    <- ggplot(iris, aes(Species, Petal.Length)) + geom_boxplot()
myppt <- pptx() %>% 
  addSlide("Title and Content") %>%
  addTitle("Sample Graph 1") %>%
  addPlot(function() { boxplot(Petal.Length ~ Species, data=iris); abline(h=5)}) %>%

  addSlide("Title and Content") %>%
  addTitle("Sample Graph 2") %>%
  addPlot(function() print(GO)) %>%
  addDate() %>% addPageNumber()
writeDoc(myppt, "c:/temp/sample.pptx")



### \̍쐬E\t
  TG <- summarise(group_by(ToothGrowth, supp, dose), m=mean(len), s=sd(len))
( TG <- as.data.frame(TG) )
FlexTable(TG)       # \̂
vanilla.table(TG)   # h̗ǂ\
light.table(TG) %>% setZebraStyle(odd="gray", even="white")

FlexTable(TG, header.columns=FALSE) %>%
  setFlexTableWidths(widths=c(1.2, 1.2, 1, 1)) %>%
  addHeaderRow(text.properties=textBold(),
  value=c("Supplement", "Dose", "Summary"), colspan=c(1, 1, 2)) %>%
  addHeaderRow(value=names(TG), text.properties=textBold()) %>%
  addFooterRow(value="Summary Statistics of ToothGrowth",
               colspan=4, text.properties=textBoldItalic())

FlexTable(TG) %>%
  spanFlexTableRows(j="supp", runs=as.character(TG$supp)) %>%
  spanFlexTableRows(j=2, from=1, to=3) %>%
  spanFlexTableColumns(i=5, from=2, to=4)

FlexTable(TG) %>%
  setRowsColors(i=3:4, colors="lightgreen") %>%
  setColumnsColors(j=2, colors="yellow") %>%
  setFlexTableBackgroundColors(j=4,
    colors=ifelse(TG$m > 20, "pink", "cyan")) %>%
  setFlexTableBackgroundColors(i=1, j=1,
    colors="gray", to="header")

FT <- light.table(TG) %>% addFooterRow(value="XXX", colspan=4)
FT[]            <- cellProperties(background.color="gray")
FT[1, 2]        <- textProperties(color="red")
FT[3:4, "m"]    <- cellProperties(background.color="yellow")
FT[to="footer"] <- parProperties(text.align="right")
FT[, 4, to="header", side="left"] <- borderProperties(width=0)

TG2   <- TG; 
TG2$m <- formatC(TG2$m, digits=1, format="f")
TG2$s <- formatC(TG2$s, digits=2, format="f")
FT    <- FlexTable(TG2)
FT[, 3:4]               <- textProperties(color="blue")
FT[, 3:4, to="header"]  <- textProperties(color="red", font.weight="bold")
FT[4:6, "m"]            <- cellProperties(background.color="cyan")
FT[, "m", to="header"]  <- cellProperties(background.color="gray")
FT[, c("dose", "supp")] <- parRight()
FT[, 1:4, to="header"]  <- parCenter()
FT

FT <- vanilla.table(TG) %>%
  addFooterRow(value="* YYY", colspan=4)
FT[TG$dose==1, "m",
  text.properties=textBold(vertical.align="superscript")] <- "*"
FT[to="footer", side="bottom"] <- borderProperties(width=0)
FT[to="footer", side="left"]   <- borderProperties(width=0)
FT[to="footer", side="right"]  <- borderProperties(width=0)
FT[3, 2, text.properties=textBold(color="red"), newpar=TRUE] <- 'X'
FT

( Table1 <- FlexTable(TG[1:3], header.columns=F) )
Table2 <- Table1 %>%
  spanFlexTableRows(j="supp", runs=as.character(TG$supp)) %>%
  spanFlexTableRows(j="dose", runs=as.character(TG$dose))
Table2[, "m"] <- paste("&plusmn;", formatC(TG$s, digits=3, format="f"))
Table2
b0 <- borderProperties(width=0)
b1 <- borderProperties(width=1)
b2 <- borderProperties(width=2, color="red", style="dashed")
Table3 <- addHeaderRow(Table2, value=c("", "Summary Statistics"), colspan=c(2,1)) %>%
  addHeaderRow(value=c("supp", "dose", "Mean &plusmn; S.D.") ) %>%
  addFooterRow(value=c("* dose unit: mg"), colspan=3) %>%
  setFlexTableBorders(footer=T, inner.vertical=b0, inner.horizontal=b1,
    outer.vertical=b0, outer.horizontal=b2) %>%
  setFlexTableWidths(rep(2,3))
Table3
Table4 <- Table3
Table4[2,1:2, to="header", side="top"] <- b0
Table4[       to="footer"]             <- cellBorderNone()
Table4[,1:3]             <- parProperties(text.align="center")
Table4[to="header"]      <- parProperties(text.align="center")
Table4[2,2, to="header"] <- pot("*", textProperties(vertical.align="superscript"))
Table4

LM     <- lm(len ~ supp+dose, data=ToothGrowth) %>%
             summary() %$% as.data.frame(coefficients)
LM[,1] <- formatC(LM[,1], digits=2, format="f")
LM[,2] <- formatC(LM[,2], digits=3, format="f")
LM[,3] <- formatC(LM[,3], digits=3, format="f")
LM[,4] <- ifelse( LM[,4] < 0.0001, "<0.0001", formatC(LM[,4], digits=4, format="f"))
LM
options( "ReporteRs-fontsize"=24)
FT_LM <- FlexTable(LM, add.rownames=TRUE,
    body.par.props   =parCenter(), 
    header.text.props=textBold(),
    header.columns   =TRUE) %>%
  setFlexTableWidths(widths=rep(2, 5)) %>%
  setFlexTableBorders(
    inner.vertical  =borderNone(),
    inner.horizontal=borderDotted(),
    outer.vertical  =borderNone(),
    outer.horizontal=borderSolid())
myppt <- pptx() %>% 
  addSlide("Title and Content") %>%
  addTitle("Sample Regression Analysis" ) %>%
  addFlexTable(FT_LM, offx=1.2, offy=2, width=24, height=12) %>%
  addDate() %>% addPageNumber()
writeDoc(myppt, "c:/temp/result.pptx")



### ̑
BP <- borderProperties(style="dashed")
TP <- textProperties(color="blue", font.weight="bold")
CP <- cellProperties(border.color="gray", border.width=2)
FT <- FlexTable(TG,
  header.text.props=textBold(),
  header.cell.props=CP,
  body.cell.props  =CP,
  body.text.props  =TP)
FT[, "dose", side="bottom"] <- BP
FT <- chprop(FT, textProperties(color="red"), j=3:4)
FT <- chprop(FT, parProperties(text="center"), to="header")
FT

BP <- borderProperties(color="black", style="solid", width=1)
FT <- FlexTable(TG)
FT[1, to="header", side="bottom"] <- BP
FT
BP <- chprop(BP, color="red", style="dashed", width=2)
FT[1, to="header", side="bottom"] <- BP
FT

FT <- light.table(TG) %>% addFooterRow(value="XXX", colspan=4) %>%
  setFlexTableBorders(
    inner.vertical  =borderProperties(width=0),
    inner.horizontal=borderProperties(width=1),
    outer.vertical  =borderProperties(width=2, col="red"),
    outer.horizontal=borderProperties(width=2, col="blue"), 
    body=TRUE, header=TRUE, footer=FALSE) %>%
  setFlexTableBorders(
    outer.vertical  =borderProperties(width=0),
    outer.horizontal=borderProperties(width=0), 
    body=FALSE, header=FALSE, footer=TRUE)

FT <- light.table(TG) %>% addFooterRow(value="* XXX", colspan=4)
FT[1,1, to="header"] <- pot("*", textProperties(vertical.align="superscript"))
FT[to="footer"]      <- textProperties(font.style="italic", font.weight="bold")
FT

PT <- pot("You", textProperties(color="red")) + " and " + 
      pot("I", textProperties(color="blue", underline=TRUE), 
        hyperlink="http://nfunao.web.fc2.com/")
FT <- light.table(TG) %>% addFooterRow(value="", colspan=4)
FT[1, 1, to="footer"] <- PT

options("ReporteRs-default-font"="Times New Roman")
options("ReporteRs-fontsize"=11)

CP <- cellProperties(border.width=0)
FT <- FlexTable(TG)
FT[1, to="header", side="bottom"] <- CP
FT
CP <- chprop(CP, border.width=1)

FT <- light.table(TG) %>% addFooterRow(value="XXX", colspan=4)
FT[, to="footer"] <- parProperties(text.align="right")
FT



### F֐̒`
demog_summary <- function (var, label, digit=1) {
  eval(substitute(TMP  <- subset(ADSL, !is.na(var) & RANDFL=="Y")))
  eval(substitute(TMP1 <- summarise(group_by(TMP, TRT01P), N=n(), MEAN=mean(var), SD=sd(var), MIN=min(var), Q1=quantile(var, pr=0.25), MEDIAN=median(var), Q3=quantile(var, pr=0.75), MAX=max(var))))
  eval(substitute(TMP2 <- summarise(TMP, N=n(), MEAN=mean(var), SD=sd(var), MIN=min(var), Q1=quantile(var, pr=0.25), MEDIAN=median(var), Q3=quantile(var, pr=0.75), MAX=max(var))))
  TMP3      <- rbind(TMP1, data.frame(TRT01P="Total", TMP2))
  TMP4      <- data.frame(VAR=rep(label, nrow(TMP3)), TMP3)
  TMP4$MEAN <- formatC(TMP4$MEAN, digits=digit, format="f")
  TMP4$SD   <- formatC(TMP4$SD,   digits=digit+1, format="f")
  TMP4$Q1   <- formatC(TMP4$Q1,   digits=digit+1, format="f")
  TMP4$Q3   <- formatC(TMP4$Q3,   digits=digit+1, format="f")
  return(TMP4)
}

demog_freq <- function(var, label) {
  for (i in 1:length(var)) {
    eval(parse(text=paste("TMP  <- subset(ADSL, !is.na(", var[i], ") & RANDFL=='Y')")))
    eval(parse(text=paste("TMP1 <- as.data.frame(table.margins(xtabs(~", var[i], "+ TRT01P, data=TMP)))")))
    TMP2 <- data.frame(VAR=rep(label[i], nrow(TMP1)), CAT=row.names(TMP1), TMP1)[-nrow(TMP1),]
    if (i==1) RESULT <- TMP2
    else      RESULT <- rbind(RESULT, TMP2)
  }
  row.names(RESULT) <- NULL
  return(RESULT)
}

kmtable <- function (paramcd, pflag, times) {
  eval(substitute(TMP <- subset(ADTTE, PARAMCD==paramcd & pflag=="Y")))
  p_num <- pchisq(survdiff(Surv(AVAL, EVENT) ~ TRTPN, data=TMP)$chisq, 1, lower=F)
  p_chr <- ifelse(p_num<0.0001, "Logrank test: p<0.0001", paste0("Logrank test: p=",formatC(p_num, digits=4, format="f")))

  maxt <- max(times)
  TMP1 <- summary(survfit(Surv(AVAL, EVENT) ~ TRTPN, data=TMP, type="kaplan-meier", 
                          error="greenwood", conf.type="plain"), times=0:maxt)
  TMP2 <- data.frame(TIME=TMP1$time, N=TMP1$n.risk, EVENT=TMP1$n.event, 
                     CENSOR=TMP1$n.censor, ESTIMATE=100*(1-TMP1$surv), 
                     SE=100*(TMP1$std.err), GROUP=as.numeric(TMP1$strata))
  TMP3 <- list(); N <- list()
  for (i in 1:2) {
    KM   <- subset(TMP2, GROUP==i); MT <- max(KM$TIME); 
    LAST <- KM[MT+1,]; LAST$N <- LAST$EVENT <- LAST$CENSOR <- 0
    if (maxt > MT) {
      for (j in (MT+1):maxt) {
        LAST$TIME <- j
        KM        <- rbind(KM, LAST)
      }
    }
    KM <- transform(KM, EVENT  =cumsum(EVENT),
                        MARKER =CENSOR,
                        CENSOR =cumsum(CENSOR),
                        LOWERCI=(ESTIMATE-qnorm(0.975)*SE),
                        UPPERCI=(ESTIMATE+qnorm(0.975)*SE))
    KM$LOWERCI <- ifelse(round(KM$ESTIMATE,8)==100, 100, 
                  ifelse(KM$LOWERCI          <=  0,   0, KM$LOWERCI))
    KM$UPPERCI <- ifelse(round(KM$ESTIMATE,8)==100, 100, 
                  ifelse(KM$UPPERCI          >=100, 100, KM$UPPERCI))
    TMP3[[i]]  <- KM
    N[[i]]     <- subset(KM, TIME %in% times, select=N)[,, drop=T]
  }
  TMP4       <- rbind(TMP3[[1]],TMP3[[2]])
  TMP4$GROUP <- factor(TMP4$GROUP, level=1:2, label=c("ABC-XXX", "Placebo"))
  TMP5       <- subset(TMP4, TIME %in% times, select=c(7, 1:5, 9:10))
  row.names(TMP4) <- NULL; row.names(TMP5) <- NULL

  TMP5$ESTIMATE <- formatC(TMP5$ESTIMATE, digits=1, format="f")
  TMP5$UPPERCI  <- formatC(TMP5$UPPERCI,  digits=1, format="f")
  TMP5$LOWERCI  <- formatC(TMP5$LOWERCI,  digits=1, format="f")
  b0    <- borderProperties(width=0)
  b1    <- borderProperties(width=1)
  TMP6  <- FlexTable(TMP5, header.columns=F) %>%
                     spanFlexTableRows(j="GROUP", runs=as.character(TMP5$GROUP))
  TABLE <- addHeaderRow(TMP6, value=c("", "95% CI"), colspan=c(6,2)) %>%
    addHeaderRow(value=c("Group", "Time", "At Risk", "Event", "Censor", "%", "Lower", "Upper") ) %>%
    setFlexTableBorders(footer=T, inner.vertical=b0, inner.horizontal=b1,
      outer.vertical=b0, outer.horizontal=b1) %>%
    setFlexTableWidths(c(1.5, rep(1,7)))
  TABLE[2,1:6,to="header",side="top"] <- borderProperties(width=0)
  TABLE[,]                            <- parProperties(text.align="center")
  TABLE[to="header"]                  <- parProperties(text.align="center")
  TABLE
  
  if (p_num < 0.05) P <- pot("Superiority of ABC-XXX to Placebo was confirmed.",     textProperties(color="red",  font.size=24))
  else              P <- pot("Superiority of ABC-XXX to Placebo was not confirmed.", textProperties(color="blue", font.size=24))
  return( list(all=TMP4, lifetable=TMP5, times=times, n1=N[[1]], n2=N[[2]], p_num=p_num, p_chr=p_chr, table=TABLE, pot=P) )
}

kmplot <- function (km_obj, xlim=c(-35,max(km_obj$times)), xlab="Days") {
  ggplot(data=km_obj$all) +
    geom_step(mapping=aes(x=TIME, y=ESTIMATE, color=GROUP, size=GROUP)) + 
    geom_point(data=subset(km_obj$all, MARKER>0), mapping=aes(x=TIME, y=ESTIMATE, color=GROUP), shape=3, size=2) +
    xlab(xlab) + ylab("Cumulative Incidence (%)") + 
    scale_size_manual(values=c(1.5,0.5)) +
    scale_x_continuous(breaks=km_obj$times,        limits=xlim) +
    scale_y_continuous(breaks=seq(0, 100, by= 20), limits=c(-8, 100)) +
    annotate("text", x=20,           y=95, label=km_obj$p_chr, color="black", fontface=2) +
    annotate("text", x=xlim[1],      y=-4, label="ABC-XXX",    color="#F8766D") +
    annotate("text", x=km_obj$times, y=-4, label=km_obj$n1,    color="#F8766D") +
    annotate("text", x=xlim[1],      y=-8, label="Placebo",    color="#00BFC4") +
    annotate("text", x=km_obj$times, y=-8, label=km_obj$n2,    color="#00BFC4")
}

riskdiff <- function (correct=TRUE) {
  ALL <- list(); k <- 1
  for (i in c("GU","DU")) {
    TMP  <- subset(ADTTE, !is.na(CNSR) & FASFL=="Y" & PARAMCD==i)
    TMP1 <- as.data.frame(table.margins(xtabs(~ TRTP + CNSR, data=TMP)))
    TMP2 <- data.frame(VAR=rep(i, nrow(TMP1)), CAT=row.names(TMP1), TMP1)[-nrow(TMP1),]

    TMP2$Yes      <- TMP2$X0
    TMP2$No       <- TMP2$X1
    BT1           <- binom.test(TMP2$X0[1], TMP2$Total[1])
    BT2           <- binom.test(TMP2$X0[2], TMP2$Total[2])
    TMP2$ESTIMATE <- c(BT1$estimate, BT2$estimate)
    TMP2$LCL1     <- c(as.vector(BT1$conf.int[1]), as.vector(BT2$conf.int[1]))
    TMP2$UCL1     <- c(as.vector(BT1$conf.int[2]), as.vector(BT2$conf.int[2]))

    n             <- TMP2$Total
    p             <- TMP2$ESTIMATE
    TMP2$DIFF     <- c(p[1] - p[2], NA)
    se            <- sqrt(p[1] * (1 - p[1]) / n[1] + p[2] * (1 - p[2]) / n[2])
    TMP2$LCL2     <- c(p[1] - p[2] - qnorm(0.975) * se, NA)
    TMP2$UCL2     <- c(p[1] - p[2] + qnorm(0.975) * se, NA)

    chisq         <- chisq.test(TMP1[1:2,1:2], correct=correct)
    TMP2$DF       <- c(as.vector(chisq$parameter), NA)
    TMP2$CHISQ    <- c(as.vector(chisq$statistic), NA)
    TMP2$P        <- c(as.vector(chisq$p.value), NA)

    row.names(TMP2) <- NULL
    ALL[[k]]        <- TMP2
    k               <- k+1
  }
  TMP1       <- rbind(ALL[[1]],ALL[[2]])[,c(1:2, 6:7, 5, 8:16)]
  TMP1$Yes   <- paste0(TMP1$Yes, " (", formatC(TMP1$ESTIMATE*100, digits=1, format="f"), ")")
  TMP1$LCL1  <- formatC(TMP1$LCL1*100,     digits=1, format="f")
  TMP1$UCL1  <- formatC(TMP1$UCL1*100,     digits=1, format="f")
  TMP1$DIFF  <- formatC(TMP1$DIFF*100,     digits=1, format="f")
  TMP1$LCL2  <- formatC(TMP1$LCL2*100,     digits=1, format="f")
  TMP1$UCL2  <- formatC(TMP1$UCL2*100,     digits=1, format="f")
  TMP1$CHISQ <- formatC(TMP1$CHISQ, digits=3, format="f")
  TMP1$P     <- ifelse(TMP1$P<0.0001, "<0.0001", formatC(TMP1$P, digits=4, format="f"))

  b0     <- borderProperties(width=0)
  b1     <- borderProperties(width=1)
  TMP2   <- FlexTable(TMP1[,c(1:5,7:8)], header.columns=F) %>%
                      spanFlexTableRows(j="VAR", runs=as.character(TMP1$VAR))
  TABLE1 <- addHeaderRow(TMP2, value=c("", "95% CI"), colspan=c(5,2)) %>%
    addHeaderRow(value=c("Test", "Group", "Yes (%)", "No", "Total", "Lower", "Upper") ) %>%
    setFlexTableBorders(footer=T, inner.vertical=b0, inner.horizontal=b1,
      outer.vertical=b0, outer.horizontal=b1) %>%
    setFlexTableWidths(c(1, 2, 1.5, rep(1.3,2), rep(1.3,2)))
  TABLE1[2,1:5,to="header",side="top"] <- borderProperties(width=0)
  TABLE1[,]                            <- parProperties(text.align="center")
  TABLE1[to="header"]                  <- parProperties(text.align="center")

  TMP1$CAT <- rep("ABC-XXX - Placebo", 4)
  TMP3     <- FlexTable(TMP1[c(1,3),c(1:2,9:11,13,12,14)], header.columns=F)
  TABLE2 <- addHeaderRow(TMP3, value=c("", "95% CI", "Chi-square Test"), colspan=c(3,2,3)) %>%
    addHeaderRow(value=c("Test", "Group", "Diff.", "Lower", "Upper", "Chisq.", "DF", "p-value") ) %>%
    setFlexTableBorders(footer=T, inner.vertical=b0, inner.horizontal=b1,
      outer.vertical=b0, outer.horizontal=b1) %>%
    setFlexTableWidths(c(1, 2.8, rep(1,6)))
  TABLE2[2,1:3,to="header",side="top"] <- borderProperties(width=0)
  TABLE2[,]                            <- parProperties(text.align="center")
  TABLE2[to="header"]                  <- parProperties(text.align="center")

  if (TMP1[1,14] < 0.05) P1 <- pot("The difference in proportions of GU was statistically significant.",
                                    textProperties(color="red",  font.size=22))
  else                   P1 <- pot("The difference in proportions of GU was not statistically significant.",
                                    textProperties(color="blue", font.size=22))
  if (TMP1[3,14] < 0.05) P2 <- pot("The difference in proportions of DU was statistically significant.",
                                    textProperties(color="red",  font.size=22))
  else                   P2 <- pot("The difference in proportions of DU was not statistically significant.",
                                    textProperties(color="blue", font.size=22))
  return( list(table1=TABLE1,table2=TABLE2, pot1=P1, pot2=P2) )
}

covadjust <- function (paramcd, pflag, cov, label, ref) {
  eval(substitute(TMP <- subset(ADTTE, PARAMCD==paramcd & pflag=="Y")))
  eval(substitute(TMP1 <- as.data.frame(summary(coxph(Surv(AVAL, EVENT) ~ relevel(factor(TRTPN), ref=ref) + cov, data=TMP))$conf.int)[1,c(1,3,4)]))
  return( data.frame(VAR=label, TMP1) )
}

adjplot <- function (adj_obj, cex=1.5, xlim=c(0,1.5), breaks=seq(xlim[1], xlim[2], 0.5)) {
  DATA          <- rbind(rep(NA,3), adj_obj[1,2:4], rep(NA,3), adj_obj[2:nrow(adj_obj),2:4])
  adj_obj[,2:4] <- round(adj_obj[,2:4],2)
  TEXT          <- rbind(c("Covariate", "HR", "95% LCL", "95% UCL"),
                         adj_obj[1,], rep(NA,4), adj_obj[2:nrow(adj_obj),])
  row.names(DATA) <- NULL
  row.names(TEXT) <- NULL
  forestplot(TEXT, DATA, graph.pos=2, hrzl_lines = gpar(col="#444444"), xlog=FALSE, boxsize=0.2, 
    col=fpColors(box="royalblue",line="darkblue", summary="royalblue"), zero=1, 
    txt_gp=fpTxtGp(cex=cex), is.summary=c(T,rep(F,nrow(adj_obj)+1)), clip=xlim, xticks=breaks)
}

subgroup <- function (paramcd, pflag, cov, label, sub, sublabel, ref) {
  eval(substitute(TMP <- subset(ADTTE, PARAMCD==paramcd & pflag=="Y" & cov==sub)))
  eval(substitute(TMP1 <- as.data.frame(summary(coxph(Surv(AVAL, EVENT) ~ relevel(factor(TRTPN), ref=ref), data=TMP))$conf.int)[1,c(1,3,4)]))
  return( data.frame(VAR=label, CAT=sublabel, TMP1) )
}

subplot <- function (sub_obj, cex=1.5, xlim=c(0,1.5), breaks=seq(xlim[1], xlim[2], 0.5)) {
  DATA          <- rbind(rep(NA,3), sub_obj[1,3:5], rep(NA,3), sub_obj[2:nrow(sub_obj),3:5])
  sub_obj[,3:5] <- round(sub_obj[,3:5],2)
  TEXT          <- rbind(c("Subgroup", "Category", "HR", "95% LCL", "95% UCL"),
                         sub_obj[1,], rep(NA,5), sub_obj[2:nrow(sub_obj),])
  row.names(DATA) <- NULL
  row.names(TEXT) <- NULL
  forestplot(TEXT, DATA, graph.pos=3, hrzl_lines = gpar(col="#444444"), xlog=FALSE, boxsize=0.2, 
    col=fpColors(box="royalblue",line="darkblue", summary="royalblue"), zero=1, 
    txt_gp=fpTxtGp(cex=cex), is.summary=c(T,rep(F,nrow(sub_obj)+1)), clip=xlim, xticks=breaks)
}

teae <- function (rel=FALSE, sae=FALSE) {
  N <- xtabs(~ TRT01A, data=subset(ADSL, SAFFL=="Y"))
  if (rel) TMP1 <- subset(ADAE, SAFFL=="Y" & TRTEMFL=="Y" & ARELN==1)
  else     TMP1 <- subset(ADAE, SAFFL=="Y" & TRTEMFL=="Y")
  if (sae) TMP1 <- subset(TMP1, AESER=="Y")
  TMP2  <- subset(distinct(TMP1, SUBJID, .keep_all=T), select=c(SAFFL, TRTA))
  TMP3  <- as.data.frame(table.margins(xtabs(~ SAFFL + TRTA, data=TMP2)))
  TMP4  <- data.frame(PT="Subjects with Any TEAEs", TMP3)[-nrow(TMP3),]

  TMP5  <- subset(distinct(TMP1, SUBJID, AEDECOD, .keep_all=T), select=c(AEDECOD, TRTA))
  TMP6  <- as.data.frame(table.margins(xtabs(~ AEDECOD + TRTA, data=TMP5)))
  TMP7  <- data.frame(PT=row.names(TMP6), TMP6)[-nrow(TMP6),]
  TMP8  <- transform(arrange(rbind(TMP4, TMP7), desc(Total)), P1=ABC.XXX/N[1], P2=Placebo/N[2])
  row.names(TMP8) <- NULL
  TMP8$PT         <- as.character(TMP8$PT)
  TMP9  <- transform(TMP8, DIFF=(P1-P2), SE=sqrt(P1*(1-P1)/N[1]+P2*(1-P2)/N[2]))
  TMP10 <- transform(TMP9, LCL=(DIFF-qnorm(0.975)*SE), UCL=(DIFF+qnorm(0.975)*SE), NO=1:nrow(TMP9))[,-8]
  return( list(table=TMP10, n=N) )
}

aeplot <- function (ae_obj, cex=1.5, xlim=c(-20,20), breaks=seq(xlim[1], xlim[2], 5)) {
  DATA <- 100*rbind(rep(NA,3), rep(NA,3), ae_obj$table[1,], rep(NA,3), ae_obj$table[2:nrow(ae_obj$table),])[,7:9]
  TMP1 <- transform(ae_obj$table, G1=paste0(ABC.XXX, " (", format(round(P1*100,1), nsmall=1), ")"), 
                                  G2=paste0(Placebo, " (", format(round(P2*100,1), nsmall=1), ")"), 
                                  DF=paste0(format(round(DIFF*100,1), nsmall=1), "%"),
                                  stringsAsFactors=F)[,c(1,11:13)]
  TEXT <- rbind(c("", "ABC-XXX", "Placebo", ""),
                c("PT Name", "n (%)", "n (%)", "Difference"),
                TMP1[1,], rep(NA,4), TMP1[2:nrow(TMP1),])
  row.names(DATA) <- NULL
  row.names(TEXT) <- NULL
  forestplot(TEXT, DATA, hrzl_lines = gpar(col="#444444"), xlog=FALSE, boxsize=0.2, 
    col=fpColors(box="royalblue",line="darkblue", summary="royalblue"), 
    txt_gp=fpTxtGp(cex=cex), is.summary=c(T,T,rep(F,nrow(ae_obj$table)+1)), clip=xlim, xticks=breaks)
}

teae_intensity <- function (rel=FALSE) {
  N    <- xtabs(~ TRT01A, data=subset(ADSL, SAFFL=="Y"))
  if (rel) TMP1 <- subset(ADAE, SAFFL=="Y" & TRTEMFL=="Y" & ARELN==1)
  else     TMP1 <- subset(ADAE, SAFFL=="Y" & TRTEMFL=="Y")
  TMP2  <- arrange(TMP1, SUBJID, desc(ASEV))
  TMP3  <- subset(distinct(TMP2, SUBJID, .keep_all=T), select=c(TRTA, ASEV))
  TMP4  <- as.data.frame(table.margins(xtabs(~ ASEV + TRTA, data=TMP3)))
  TMP5  <- data.frame(PT="Subjects with Any TEAEs", Intensity=row.names(TMP4), TMP4)[-nrow(TMP4),]

  TMP6  <- arrange(TMP1, SUBJID, AEDECOD, desc(ASEV))
  TMP7  <- subset(distinct(TMP6, SUBJID, AEDECOD, .keep_all=T), select=c(TRTA, AEDECOD, ASEV))
  TMP8  <- as.data.frame(ftable(TMP7$ASEV, TMP7$AEDECOD, TMP7$TRTA))
  TMP9  <- dcast(TMP8, Var2 + Var1 ~ Var3, value.var="Freq")
  TMP10 <- transform(data.frame(PT=TMP9[,1], Intensity=TMP9[,2], ABC.XXX=TMP9[,3], Placebo=TMP9[,4]),
                     Total=(ABC.XXX+Placebo))
  TMP11 <- rbind(TMP5, TMP10)
  TMP11$PT         <- as.character(TMP11$PT)
  TMP11$Intensity  <- as.character(TMP11$Intensity)

  ALL              <- teae()$table
  ALL$Intensity    <- rep("", nrow(ALL))
  TMP11            <- full_join(TMP11, select(ALL, PT, NO), by="PT")
  TMP12            <- rbind(TMP11, select(ALL, PT, Intensity, ABC.XXX, Placebo, Total, NO))
  TMP12            <- arrange(TMP12, NO, Intensity)
  TMP12$Intensity  <- ifelse(TMP12$Intensity != "", TMP12$Intensity, "Overall")
  row.names(TMP12) <- NULL
  TMP13            <- transform(TMP12, P1=ABC.XXX/N[1], P2=Placebo/N[2])[,]
  return( list(table=TMP13[,c(1:5,7:8)], n=N) )
}



### FX̃f[^쐬
# install.packages(c("epiR","epitools","forestplot","haven","reshape2"), dep=T)
library(dplyr)
library(epiR)
library(epitools)
library(forestplot)
library(ggplot2)
library(haven)
library(magrittr)
library(reshape2)
library(ReporteRs)

ADAE          <- read_sas("C:/temp/adae.sas7bdat")
ADSL          <- read_sas("C:/temp/adsl.sas7bdat")
ADTTE         <- read_sas("C:/temp/adtte.sas7bdat")
ADSL$AGEGR1   <- factor(ADSL$AGEGR1,   levels=c("Min<= - <65","65<= - <=Max"))
ADSL$ALCOHOL  <- factor(ADSL$ALCOHOL,  levels=c("Yes","No"))
ADSL$BMIGR1   <- factor(ADSL$BMIGR1,   levels=c("Min<= - <25.0","25.0<= - <=Max"))
ADSL$CAFFEINE <- factor(ADSL$CAFFEINE, levels=c("Yes","No"))
ADSL$HPYLORI  <- factor(ADSL$HPYLORI,  levels=c("Positive","Negative"))
ADSL$SEX      <- factor(ADSL$SEX,      levels=c("M","F"), labels=c("Male","Female"))
ADSL$TOBACCO  <- factor(ADSL$TOBACCO,  levels=c("Yes","No"))
ADTTE$EVENT   <- 1-ADTTE$CNSR

options("ReporteRs-fontsize"=16)

DEMOG1       <-               demog_summary(AGE  , "Age (years)",  1)
DEMOG1       <- rbind(DEMOG1, demog_summary(BMIBL, "BMI (kg/m^2)", 2))
TMP1         <- FlexTable(DEMOG1, header.columns=F) %>%
                  spanFlexTableRows(j="VAR", runs=as.character(DEMOG1$VAR))
DEMOG_TABLE1 <- addHeaderRow(TMP1,
                  value=c("Variable", "Group", "N", "Mean", "S.D.", "Min.", "Q1", "Median", "Q3", "Max.") ) %>%
                  setFlexTableWidths(c(1.6, 1.6, rep(0.8,8)))
DEMOG_TABLE1[,]           <- parProperties(text.align="center")
DEMOG_TABLE1[to="header"] <- parProperties(text.align="center")

DEMOG2         <- demog_freq(c("AGEGR1","ALCOHOL","BMIGR1","CAFFEINE","HPYLORI","SEX","TOBACCO"), 
                             c("Age (years)","Alcohol Consumption","BMI (kg/m^2)","Caffeine Consumption",
                               "H. pylori Infection","Gender","Tobacco Consumption"))
N              <- xtabs(~ TRT01P, data=subset(ADSL, RANDFL=="Y"))
DEMOG2$ABC.XXX <- paste0(DEMOG2$ABC.XXX, " (", formatC(DEMOG2$ABC.XXX/N[1]*100, digits=1, format="f"), ")")
DEMOG2$Placebo <- paste0(DEMOG2$Placebo, " (", formatC(DEMOG2$Placebo/N[2]*100, digits=1, format="f"), ")")
TMP            <- FlexTable(DEMOG2, header.columns=F) %>%
                    spanFlexTableRows(j="VAR", runs=as.character(DEMOG2$VAR))
DEMOG_TABLE2   <- addHeaderRow(TMP,
                    value=c("Variable", "Category", 
                            paste0("ABC-XXX\n", "(n=", N[1],   ")"),
                            paste0("Placebo\n", "(n=", N[2],   ")"),
                            paste0("Total\n",   "(n=", sum(N), ")"))) %>%
                    setFlexTableWidths(c(2.8, 2.4, rep(1.5,3)))
DEMOG_TABLE2[,]           <- parProperties(text.align="center")
DEMOG_TABLE2[to="header"] <- parProperties(text.align="center")

options("ReporteRs-fontsize"=20)

T1 <- kmtable("GU", FASFL,   c(0,100,200,300,400))
T2 <- kmtable("GU", PPROTFL, c(0,100,200,300,400))
T3 <- kmtable("DU", FASFL,   c(0,100,200,300,400))

ADDITIONAL <- riskdiff()

ADJUST <-               covadjust("GU", FASFL, 1       , "Overall", 2)
ADJUST <- rbind(ADJUST, covadjust("GU", FASFL, AGE     , "Age", 2))
ADJUST <- rbind(ADJUST, covadjust("GU", FASFL, SEX     , "Gender", 2))
ADJUST <- rbind(ADJUST, covadjust("GU", FASFL, BMIBL   , "BMI", 2))
ADJUST <- rbind(ADJUST, covadjust("GU", FASFL, HPYLORI , "H. pylori Infection", 2))
ADJUST <- rbind(ADJUST, covadjust("GU", FASFL, CAFFEINE, "Caffeine Consumption", 2))
ADJUST <- rbind(ADJUST, covadjust("GU", FASFL, ALCOHOL , "Alcohol Consumption", 2))
ADJUST <- rbind(ADJUST, covadjust("GU", FASFL, TOBACCO , "Tobacco Consumption", 2))
row.names(ADJUST) <- NULL
ADJUST$VAR        <- as.character(ADJUST$VAR)

SUB <-            subgroup("GU", FASFL, FASFL   , "Overall", "Y", "", 2)
SUB <- rbind(SUB, subgroup("GU", FASFL, AGEGR1N , "Age", 1, "Min<= - <65", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, AGEGR1N , "Age", 2, "65<= - <=Max", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, SEX     , "Gender", "M", "Male", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, SEX     , "Gender", "F", "Female", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, BMIGR1N , "BMI", 1, "Min<= - <25", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, BMIGR1N , "BMI", 2, "25<= - <=Max", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, HPYLORI , "H. pylori Infection", "Positive", "Positive", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, HPYLORI , "H. pylori Infection", "Negative", "Negative", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, CAFFEINE, "Caffeine Consumption", "Yes", "Yes", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, CAFFEINE, "Caffeine Consumption", "No", "No", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, ALCOHOL , "Alcohol Consumption", "Yes", "Yes", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, ALCOHOL , "Alcohol Consumption", "No", "No", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, TOBACCO , "Tobacco Consumption", "Yes", "Yes", 2))
SUB <- rbind(SUB, subgroup("GU", FASFL, TOBACCO , "Tobacco Consumption", "No", "No", 2))
row.names(SUB) <- NULL
SUB$VAR        <- as.character(SUB$VAR)
SUB$CAT        <- as.character(SUB$CAT)

options("ReporteRs-fontsize"=14)

PT_NUM            <- 4   # 1 łɕ\PT̐
INT               <- teae_intensity()
N                 <- INT$n
INT$table$ABC.XXX <- paste0(INT$table$ABC.XXX, " (", formatC(INT$table$P1*100, digits=1, format="f"), ")")
INT$table$Placebo <- paste0(INT$table$Placebo, " (", formatC(INT$table$P2*100, digits=1, format="f"), ")")
INT               <- INT$table[,1:4]
x                 <- ceiling((nrow(INT)-4)/(4*PT_NUM))
INT_TABLE         <- list()
for (i in 1:x) {
  if (i < x || (i == x && (nrow(INT)-4)%%(4*PT_NUM)==0)) {
    TMP <- INT[c(1:4,(4+(4*PT_NUM)*(i-1)+1):(4+(4*PT_NUM)*(i-1)+(4*PT_NUM))),]
    TMP <- FlexTable(TMP, header.columns=F) %>%
             spanFlexTableRows(j="PT", runs=as.character(TMP$PT))
    TMP <- addHeaderRow(TMP,
             value=c("PT Name", "Intensity", 
                      paste0("ABC-XXX\n", "(n=", N[1], ")"),
                      paste0("Placebo\n", "(n=", N[2], ")"))) %>%
             setFlexTableWidths(c(4.5, 1.5, 1.5, 1.5))
    TMP[,1]               <- parProperties(text.align="left")
    TMP[,2:4]             <- parProperties(text.align="center")
    TMP[to="header"]      <- parProperties(text.align="center")
    TMP[4, side="bottom"] <- borderProperties(width=3)
    INT_TABLE[[i]]   <- TMP
  } else {
    TMP <- INT[c(1:4,(4+(4*PT_NUM)*(i-1)+1):(4+(4*PT_NUM)*(i-1)+((nrow(INT)-4)%%(4*PT_NUM)))),]
    TMP <- FlexTable(TMP, header.columns=F) %>%
             spanFlexTableRows(j="PT", runs=as.character(TMP$PT))
    TMP <- addHeaderRow(TMP,
             value=c("PT Name", "Intensity", 
                      paste0("ABC-XXX\n", "(n=", N[1], ")"),
                      paste0("Placebo\n", "(n=", N[2], ")"))) %>%
             setFlexTableWidths(c(4.5, 1.5, 1.5, 1.5))
    TMP[,1]               <- parProperties(text.align="left")
    TMP[,2:4]             <- parProperties(text.align="center")
    TMP[to="header"]      <- parProperties(text.align="center")
    TMP[4, side="bottom"] <- borderProperties(width=3)
    INT_TABLE[[i]]   <- TMP
  }
}

bmp(filename="C:/temp/adj.bmp", width=960, height = 480)
  adjplot(ADJUST, cex=1.5)
  dev.off()
bmp(filename="C:/temp/sub.bmp", width=960, height = 480)
  subplot(SUB, cex=1.3)
  dev.off()
bmp(filename="C:/temp/teae1.bmp", width=960, height = 480)
  ALL <- teae()
  aeplot(ALL, cex=1.2, xlim=c(-15,10))
  dev.off()
bmp(filename="C:/temp/teae2.bmp", width=960, height = 480)
  ALL <- teae(rel=TRUE)
  aeplot(ALL, cex=1.3, xlim=c(-15,10))
  dev.off()
bmp(filename="C:/temp/teae3.bmp", width=960, height = 480)
  ALL <- teae(sae=TRUE)
  aeplot(ALL, cex=1.5, xlim=c(-15,10))
  dev.off()



### F͌ʃXCh̍쐬
myppt <- pptx(template="C:/temp/nds.pptx")
myppt <- myppt %>% 
  addSlide("Title Slide") %>%
  addTitle("ABC-XXX Phase 3 Study" ) %>%
  addSubtitle("Flash Result" ) %>%
  addFooter("01JAN2017") %>%

  addSlide("Title and Content") %>%
  addTitle("Demographics and Baseline Characteristics" ) %>%
  addFlexTable(DEMOG_TABLE1, offx=0.1, offy=1.5, width=10, height=10) %>%
  addPageNumber() %>%

  addSlide("Title and Content") %>%
  addTitle("Demographics and Baseline Characteristics" ) %>%
  addFlexTable(DEMOG_TABLE2, offx=0.1, offy=1.5, width=10, height=10) %>%
  addPageNumber() %>%

  addSlide("Two Content") %>%
  addTitle("Cumulative Incidence of GU [FAS]" ) %>%
  addPlot(function() print( kmplot(T1) ), offx=0, offy=2.0, width=10, height=5) %>%
  addParagraph(value=T1$pot) %>%
  addPageNumber() %>%
  addSlide("Title and Content") %>%
  addTitle("Life Table of GU [FAS]" ) %>%
  addFlexTable(T1$table) %>%
  addPageNumber() %>%

  addSlide("Two Content") %>%
  addTitle("Cumulative Incidence of GU [PPS]" ) %>%
  addPlot(function() print( kmplot(T2) ), offx=0, offy=2.0, width=10, height=5) %>%
  addParagraph(value=T2$pot) %>%
  addPageNumber() %>%
  addSlide("Title and Content") %>%
  addTitle("Life Table of GU [PPS]" ) %>%
  addFlexTable(T2$table) %>%
  addPageNumber() %>%

  addSlide("Two Content") %>%
  addTitle("Cumulative Incidence of DU [FAS]" ) %>%
  addPlot(function() print( kmplot(T3) ), offx=0, offy=2.0, width=10, height=5) %>%
  addParagraph(value=T3$pot) %>%
  addPageNumber() %>%
  addSlide("Title and Content") %>%
  addTitle("Life Table of DU [FAS]" ) %>%
  addFlexTable(T3$table) %>%
  addPageNumber() %>%

  addSlide("Two Content") %>%
  addTitle("Proportion of GU/DU [FAS]" ) %>%
  addParagraph(value=set_of_paragraphs(ADDITIONAL$pot1,ADDITIONAL$pot2)) %>%
  addFlexTable(ADDITIONAL$table1, offx=0.1, offy=2.2, width=10, height=5) %>%
  addFlexTable(ADDITIONAL$table2, offx=0.1, offy=4.7, width=10, height=5) %>%
  addPageNumber() %>%

  addSlide("Title and Content") %>%
  addTitle("Covariate Adjusted Analysis") %>%
  addImage("C:/temp/adj.bmp", offx=0, offy=1.1, width=10, height=6) %>%
  addPageNumber() %>% 

  addSlide("Title and Content") %>%
  addTitle("Subgroup Analysis") %>%
  addImage("C:/temp/sub.bmp", offx=0, offy=1.1, width=10, height=6) %>%
  addPageNumber() %>% 

  addSlide("Title and Content") %>%
  addTitle("All TEAEs") %>%
  addImage("C:/temp/teae1.bmp", offx=0, offy=1.1, width=10, height=6) %>%
  addDate("TEAE: Treatment Emergent Adverse Event") %>% addPageNumber() %>% 

  addSlide("Title and Content") %>%
  addTitle("Drug-related TEAEs") %>%
  addImage("C:/temp/teae2.bmp", offx=0, offy=1.1, width=10, height=6) %>%
  addDate("TEAE: Treatment Emergent Adverse Event") %>% addPageNumber()

for (i in 1:length(INT_TABLE)) {
  myppt <- myppt %>% 
    addSlide("Title and Content") %>%
    addTitle("Intensity of TEAEs" ) %>%
    addFlexTable(INT_TABLE[[i]]) %>%
    addDate("TEAE: Treatment Emergent Adverse Event") %>% addPageNumber()
}

myppt <- myppt %>% 
  addSlide("Title and Content") %>%
  addTitle("SAEs") %>%
  addImage("C:/temp/teae3.bmp", offx=0, offy=1.1, width=10, height=6) %>%
  addPageNumber()
writeDoc(myppt, "c:/temp/result.pptx")
